        DEVICE ZXSPECTRUM128
		org	#6000
begin
 include "TSPor.inc"

run_part:
 ld bc,TSConfig
 xor a
 out (c),a

 ld a,6,bc,SysConfig:out (c),a

; VIDEO
VID_256X192     equ $00
VID_320X200     equ $40
VID_320X240     equ $80
VID_360X288     equ $C0
VID_ZX          equ $00
VID_16C         equ $01
VID_256C        equ $02
VID_TEXT        equ $03
VID_NOGFX       equ $20
; TSU
TSU_T0ZEN		equ $04
TSU_T1ZEN		equ $08
TSU_T0EN		equ $20
TSU_T1EN		equ $40
TSU_SEN			equ $80

;---zero video
 ld a,11;10 xor 1,font at page 10
inf_zp:
 call clear_page_dma

 LD  BC,VPage
 LD  A,11
 OUT (C),A

 ld bc,Page3
 OUT (C),A

 LD  BC,VConfig
 LD  A,VID_TEXT;VID_320X200|VID_16C
 OUT (C),A

;palette
 ld bc, FMAddr
 ld a, %00010000
 out (c), a
;load CRAM
 ld hl,inf_pal_b
 ld de,0
 ld bc,inf_pal_e-inf_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a

 ld bc,PalSel
 ld a,0
 out (c),a

 ld a,4,bc,Border:out (c),a

;$C080 - attributes: Paper.ink(4 bit)
 ld hl,$C000
 ld b,0
fil:
 ld (hl),1:inc l
; inc b
; ld (hl),4:inc l
 jr nz,fil
 jr $
;-----------------------------------------------------------------------------
clear_page_dma:
 push af
 ld bc,Page3
 out (c),a
 ld hl,$3333*0
 ld (#c000),hl
 ld bc,#1AAF
 ld hl,$C000
 out (c),l;DMASAddrL    EQU	#1AAF
 inc b
 out (c),h;l;DMASAddrH    EQU	#1BAF
 inc b

 out (c),a;h;DMASAddrX    EQU	#1CAF
 inc b
;TSL:;2.  DMADAddrL   2,     8194 ,  2 ,  .  Fill  Src  Dest  
 ld l,2
 out (c),l;DMADAddrL    EQU	#1DAF
 inc b
 out (c),h;l;DMADAddrH    EQU	#1EAF
 inc b
 out (c),a;h;DMADAddrX    EQU	#1FAF
 ld l,255
 ld b,#26

;		defb #28,200	;
;		defb #26,#ff	;
;		defb #27,%00000100    ; DMA_FILL

 out (c),l;DMALen    EQU	#26AF
 inc b
 inc b
 ld a,31;15+2;(15+1)*2=32, 32*512=16384
 out (c),a;;l;DMANum    EQU	#28AF
 dec b
 ld a,%00000100; FILL->RAM
 out (c),a;DMACtrl   EQU	#27AF
waitdma1:
 inf
 jp m,waitdma1
 pop af
 ret
;----------------------
inf_pal_b:
 dw 1024*0+32*0+0;R.G.B-0
 dw 1024*9+32*2+6;R.G.B-1
 dw 1024*17+32*8+14;R.G.B-2
 dw 1024*29+32*19+27;R.G.B-3
 dw 1024*0+32*0+0;R.G.B-4
inf_pal_e:


end
	display /d,end-begin
	savebin "tm.bin",begin,end-begin


	LUA ALLPASS
	local fp = assert(io.open("tm.ini", "wb"))

	fp:write(";Description of a build - up to 32 chars\r\n")
	fp:write("Desc = textmode\r\n")

	fp:write(";Start address\r\n")

	local ss=tostring( sj.get_label("run_part") )
	ss=string.gsub(ss , "%s", "")
	fp:write("Start =")
	fp:write(string.format("#%x",ss) )
	fp:write("\r\n")

	fp:write(";SP adddress\r\n")
	fp:write("Stack = 24575\r\n")

	fp:write(";Resident address (16 bytes long)\r\n")
	fp:write("Resident = #5B00\r\n")
	
	fp:write(";Page at #C000 when started\r\n")
	fp:write("Page3 = 0\r\n")

	fp:write("; CPU clock: 0 - 3,5MHz / 1 - 7MHz / 2 - 14MHz / 3 - 14+MHz\r\n")
	fp:write("Clock = 1\r\n")

	fp:write("; INT: 0 - DI / 1 - EI\r\n")
	fp:write("INT = 0\r\n")

	fp:write(";Pager address (0 - not used)\r\n")
	fp:write("Pager = 0\r\n")

	fp:write("; Blocks description: address (512 multiple, #C000-#FE00), page number, filename\r\n")
	fp:write("Block = #E000,5,tm.bin\r\n")

	fp:write("Block = #C000,10,Rus.fnt\r\n")

	assert(fp:close())
	ENDLUA

